/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the Template type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Template{}

// Template Message Template
type Template struct {
	Name string `json:"name"`
	OrganizationId string `json:"organization_id"`
	GatewayId *string `json:"gateway_id,omitempty"`
	Type TemplateType `json:"type"`
	Visibility TemplateVisibility `json:"visibility"`
	Language string `json:"language"`
	Internal *InternalTemplate `json:"internal,omitempty"`
	Whatsapp *WhatsAppTemplate `json:"whatsapp,omitempty"`
	WhatsappDefaults *WhatsAppTemplateDefaults `json:"whatsapp_defaults,omitempty"`
	Id string `json:"id"`
	Status string `json:"status"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewTemplate instantiates a new Template object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplate(name string, organizationId string, type_ TemplateType, visibility TemplateVisibility, language string, id string, status string, createdAt time.Time, updatedAt time.Time) *Template {
	this := Template{}
	this.Name = name
	this.OrganizationId = organizationId
	this.Type = type_
	this.Visibility = visibility
	this.Language = language
	this.Id = id
	this.Status = status
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewTemplateWithDefaults instantiates a new Template object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplateWithDefaults() *Template {
	this := Template{}
	return &this
}

// GetName returns the Name field value
func (o *Template) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Template) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Template) SetName(v string) {
	o.Name = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *Template) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *Template) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *Template) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetGatewayId returns the GatewayId field value if set, zero value otherwise.
func (o *Template) GetGatewayId() string {
	if o == nil || IsNil(o.GatewayId) {
		var ret string
		return ret
	}
	return *o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Template) GetGatewayIdOk() (*string, bool) {
	if o == nil || IsNil(o.GatewayId) {
		return nil, false
	}
	return o.GatewayId, true
}

// HasGatewayId returns a boolean if a field has been set.
func (o *Template) HasGatewayId() bool {
	if o != nil && !IsNil(o.GatewayId) {
		return true
	}

	return false
}

// SetGatewayId gets a reference to the given string and assigns it to the GatewayId field.
func (o *Template) SetGatewayId(v string) {
	o.GatewayId = &v
}

// GetType returns the Type field value
func (o *Template) GetType() TemplateType {
	if o == nil {
		var ret TemplateType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *Template) GetTypeOk() (*TemplateType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *Template) SetType(v TemplateType) {
	o.Type = v
}

// GetVisibility returns the Visibility field value
func (o *Template) GetVisibility() TemplateVisibility {
	if o == nil {
		var ret TemplateVisibility
		return ret
	}

	return o.Visibility
}

// GetVisibilityOk returns a tuple with the Visibility field value
// and a boolean to check if the value has been set.
func (o *Template) GetVisibilityOk() (*TemplateVisibility, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Visibility, true
}

// SetVisibility sets field value
func (o *Template) SetVisibility(v TemplateVisibility) {
	o.Visibility = v
}

// GetLanguage returns the Language field value
func (o *Template) GetLanguage() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Language
}

// GetLanguageOk returns a tuple with the Language field value
// and a boolean to check if the value has been set.
func (o *Template) GetLanguageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Language, true
}

// SetLanguage sets field value
func (o *Template) SetLanguage(v string) {
	o.Language = v
}

// GetInternal returns the Internal field value if set, zero value otherwise.
func (o *Template) GetInternal() InternalTemplate {
	if o == nil || IsNil(o.Internal) {
		var ret InternalTemplate
		return ret
	}
	return *o.Internal
}

// GetInternalOk returns a tuple with the Internal field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Template) GetInternalOk() (*InternalTemplate, bool) {
	if o == nil || IsNil(o.Internal) {
		return nil, false
	}
	return o.Internal, true
}

// HasInternal returns a boolean if a field has been set.
func (o *Template) HasInternal() bool {
	if o != nil && !IsNil(o.Internal) {
		return true
	}

	return false
}

// SetInternal gets a reference to the given InternalTemplate and assigns it to the Internal field.
func (o *Template) SetInternal(v InternalTemplate) {
	o.Internal = &v
}

// GetWhatsapp returns the Whatsapp field value if set, zero value otherwise.
func (o *Template) GetWhatsapp() WhatsAppTemplate {
	if o == nil || IsNil(o.Whatsapp) {
		var ret WhatsAppTemplate
		return ret
	}
	return *o.Whatsapp
}

// GetWhatsappOk returns a tuple with the Whatsapp field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Template) GetWhatsappOk() (*WhatsAppTemplate, bool) {
	if o == nil || IsNil(o.Whatsapp) {
		return nil, false
	}
	return o.Whatsapp, true
}

// HasWhatsapp returns a boolean if a field has been set.
func (o *Template) HasWhatsapp() bool {
	if o != nil && !IsNil(o.Whatsapp) {
		return true
	}

	return false
}

// SetWhatsapp gets a reference to the given WhatsAppTemplate and assigns it to the Whatsapp field.
func (o *Template) SetWhatsapp(v WhatsAppTemplate) {
	o.Whatsapp = &v
}

// GetWhatsappDefaults returns the WhatsappDefaults field value if set, zero value otherwise.
func (o *Template) GetWhatsappDefaults() WhatsAppTemplateDefaults {
	if o == nil || IsNil(o.WhatsappDefaults) {
		var ret WhatsAppTemplateDefaults
		return ret
	}
	return *o.WhatsappDefaults
}

// GetWhatsappDefaultsOk returns a tuple with the WhatsappDefaults field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Template) GetWhatsappDefaultsOk() (*WhatsAppTemplateDefaults, bool) {
	if o == nil || IsNil(o.WhatsappDefaults) {
		return nil, false
	}
	return o.WhatsappDefaults, true
}

// HasWhatsappDefaults returns a boolean if a field has been set.
func (o *Template) HasWhatsappDefaults() bool {
	if o != nil && !IsNil(o.WhatsappDefaults) {
		return true
	}

	return false
}

// SetWhatsappDefaults gets a reference to the given WhatsAppTemplateDefaults and assigns it to the WhatsappDefaults field.
func (o *Template) SetWhatsappDefaults(v WhatsAppTemplateDefaults) {
	o.WhatsappDefaults = &v
}

// GetId returns the Id field value
func (o *Template) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Template) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Template) SetId(v string) {
	o.Id = v
}

// GetStatus returns the Status field value
func (o *Template) GetStatus() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *Template) GetStatusOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *Template) SetStatus(v string) {
	o.Status = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Template) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Template) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Template) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *Template) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *Template) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *Template) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o Template) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Template) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["organization_id"] = o.OrganizationId
	if !IsNil(o.GatewayId) {
		toSerialize["gateway_id"] = o.GatewayId
	}
	toSerialize["type"] = o.Type
	toSerialize["visibility"] = o.Visibility
	toSerialize["language"] = o.Language
	if !IsNil(o.Internal) {
		toSerialize["internal"] = o.Internal
	}
	if !IsNil(o.Whatsapp) {
		toSerialize["whatsapp"] = o.Whatsapp
	}
	if !IsNil(o.WhatsappDefaults) {
		toSerialize["whatsapp_defaults"] = o.WhatsappDefaults
	}
	toSerialize["id"] = o.Id
	toSerialize["status"] = o.Status
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableTemplate struct {
	value *Template
	isSet bool
}

func (v NullableTemplate) Get() *Template {
	return v.value
}

func (v *NullableTemplate) Set(val *Template) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplate) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplate(val *Template) *NullableTemplate {
	return &NullableTemplate{value: val, isSet: true}
}

func (v NullableTemplate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


